/*
pos.h
Copyright (C)2001  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Don't write to me at: kingsley@bananahead.com 

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
   BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#ifndef _BHHDR_H_
#define _BHHDR_H_

#if (defined(__unix__) || defined(unix)) && !defined(USG)
#include <sys/param.h>
#endif

#ifndef __STDC_ISO_10646__
#define __STDC_ISO_10646__  200104L
#endif

#include <bhver.h>

#ifndef _SYS_SOCKET_H
#include <sys/socket.h>
#endif

#ifndef _NETINET_IN_H
#include <netinet/in.h>
#endif

#ifndef _ARPA_INET_H
#include <arpa/inet.h>
#endif

#ifndef _NETDB_H
#include <netdb.h>
#endif

#ifndef __NETINET_IP_H
#include <netinet/ip.h>
#endif

#ifndef _NETINET_TCP_H
#include <netinet/tcp.h>
#endif

#ifndef _NETINET_IP6_H
#include <netinet/ip6.h>
#endif

#ifdef   __cplusplus
extern "C" {
#endif

/*\defgroup protocol @(*/

/*******************************************
 *
 * Basic Header Stuff
 *
 *******************************************/

/* Message Types */
#define BHPOS_TYPE_NULL        0
#define BHPOS_TYPE_SYSTEM      1
#define BHPOS_TYPE_POST        2
#define BHPOS_TYPE_SERVICE     3
#define BHPOS_TYPE_INFO        4
#define BHPOS_TYPE_SCALES      5
#define BHPOS_TYPE_RPRINTER    6
#define BHPOS_TYPE_ENTRY       7
#define BHPOS_TYPE_ATTENDANCE  8
#define BHPOS_TYPE_CUSTOM      9
#define BHPOS_TYPE_RAWSQL      10
#define BHPOS_TYPE_ERROR       11
#define BHPOS_TYPE_SYNCH       12
#define BHPOS_TYPE_SERVERSIDE  13
#define BHPOS_TYPE_GOODS       14
#define BHPOS_TYPE_MENU        15


/******************************************
 *
 * system commands 
 *
 ******************************************/
#define BHMSG_SYSTEM_CONNECTION     1
#define BHMSG_SYSTEM_VERSION        2
#define BHMSG_SYSTEM_AUTHENTICATE   3
#define BHMSG_SYSTEM_SHUTDOWN       4
#define BHMSG_SYSTEM_LOGIN          5
#define BHMSG_SYSTEM_INTERFACE      6
#define BHMSG_SYSTEM_MESSAGE        7
#define BHMSG_SYSTEM_QUERY          8
#define BHMSG_SYSTEM_TIME           9
#define BHMSG_SYSTEM_STATISTICS     10
#define BHMSG_SYSTEM_PROCESS        11
#define BHMSG_SYSTEM_MAP            12
#define BHMSG_SYSTEM_SERVICE        13
#define BHMSG_SYSTEM_USER           14
#define BHMSG_SYSTEM_MULTIMASTER    128
#define BHMSG_SYSTEM_UPS            129
#define BHMSG_SYSTEM_RAID           130
#define BHMSG_SYSTEM_DEBUG          255


/* system connect sub-commands */
#define BHMSG_SYSTEM_CONNECT           1
#define BHMSG_SYSTEM_DISCONNECT        2
#define BHMSG_SYSTEM_RECONNECT         3
#define BHMSG_SYSTEM_HELLSTEETH        4
#define BHMSG_SYSTEM_TRANSRESTORE      5
#define BHMSG_SYSTEM_RESTORERFUSE      6
#define BHMSG_SYSTEM_SCONNECT          7

/* system version sub-commands */
#define BHMSG_SYSTEM_VERSION_SERVER    1
#define BHMSG_SYSTEM_VERSION_CLIENT    2
#define BHMSG_SYSTEM_VERSION_PROTOCOL  3

/* system authorize sub-commands */
#define BHMSG_SYSTEM_AUTHORIZE_1       1
#define BHMSG_SYSTEM_AUTHORIZE_2       2
#define BHMSG_SYSTEM_AUTHORIZE_3       3

/* system shutdown sub-commands */
#define BHMSG_SYSTEM_SHUTDOWN_SHUTDOWN 1
#define BHMSG_SYSTEM_SHUTDOWN_REBOOT   2
#define BHMSG_SYSTEM_SHUTDOWN_RESTART  3
#define BHMSG_SYSTEM_SHUTDOWN_SLEEP    4

/* system login sub-commands */
#define BHMSG_SYSTEM_LOGIN_LOGIN       1
#define BHMSG_SYSTEM_LOGIN_LIPASSIVE   2
#define BHMSG_SYSTEM_LOGIN_BARCODE     3
#define BHMSG_SYSTEM_LOGIN_MAGSWIPE    4
#define BHMSG_SYSTEM_LOGIN_SMARTCARD   5
#define BHMSG_SYSTEM_LOGIN_LOGINEXT    6

#define BHMSG_SYSTEM_LOGIN_LOGOUT      128
#define BHMSG_SYSTEM_LOGIN_LOPASSIVE   129
#define BHMSG_SYSTEM_LOGIN_LOGSUPER    130
#define BHMSG_SYSTEM_LOGIN_USERCHANGE  131

/* system interface sub-commands */
#define BHMSG_SYSTEM_INTERFACE_LOGIN      1
#define BHMSG_SYSTEM_INTERFACE_LOGOUT     2
#define BHMSG_SYSTEM_INTERFACE_BARCODE    3
#define BHMSG_SYSTEM_INTERFACE_MAGSWIPE   4
#define BHMSG_SYSTEM_INTERFACE_SMARTCARD  5

/* system map sub-commands */
#define BHMSG_SYSTEM_MAP_RELOAD           1
#define BHMSG_SYSTEM_MAP_LOAD             2

/* system service sub-commands */
#define BHMSG_SYSTEM_SERVICE_GET          1
#define BHMSG_SYSTEM_SERVICE_SET          2
#define BHMSG_SYSTEM_SERVICE_MONEYUNIT    3
#define BHMSG_SYSTEM_SERVICE_DEFCASHD     4
#define BHMSG_SYSTEM_SERVICE_CACHERELOAD  5

/* system service Ex */
#define BHMSG_SYSTEM_SERVICE_GET_STATUS   1
#define BHMSG_SYSTEM_SERVICE_GET_MODE     2
#define BHMSG_SYSTEM_SERVICE_GET_KEYMAP   3
#define BHMSG_SYSTEM_SERVICE_SET_KEYMAP   4

/* system user */
#define BHMSG_SYSTEM_USER_DISCOUNT  1

/* system proc sub-commands */
#define BHMSG_SYSTEM_PROCESS_INFO   1
#define BHMSG_SYSTEM_PROCESS_KILL   2

/* system multi-master sub-commands */
#define BHMSG_SYSTEM_MULTIMASTER_DISCOVERY      1
#define BHMSG_SYSTEM_MULTIMASTER_TICK           2
#define BHMSG_SYSTEM_MULTIMASTER_TICKKICK       3
#define BHMSG_SYSTEM_MULTIMASTER_TICKCHK        4
#define BHMSG_SYSTEM_MULTIMASTER_SCATTER        5
#define BHMSG_SYSTEM_MULTIMASTER_GATHER         6
#define BHMSG_SYSTEM_MULTIMASTER_SYNCHSTART     7
#define BHMSG_SYSTEM_MULTIMASTER_SYNCHINFO      8
#define BHMSG_SYSTEM_MULTIMASTER_SYNCHEND       9
#define BHMSG_SYSTEM_MULTIMASTER_SYNCHROLLBACK  10

/*****************************************************************
 *
 * POST commands 
 *
 ****************************************************************/
#define BHMSG_POST_PLU              1
#define BHMSG_POST_TRANSACTION      2
#define BHMSG_POST_QUERY            3
#define BHMSG_POST_ADJUST           4
#define BHMSG_POST_SERVICE          5
#define BHMSG_POST_PRINTER          6
#define BHMSG_POST_STATE            7
#define BHMSG_POST_LIST             8
#define BHMSG_POST_STOCKTAKE        9
#define BHMSG_POST_SIGNATURE        10
#define BHMSG_POST_BLINDBALANCE     11
#define BHMSG_POST_DELIVERY         12
#define BHMSG_POST_RENTAL           13
#define BHMSG_POST_DISCREPANCY      14
#define BHMSG_POST_CUSTOMER         15
#define BHMSG_POST_EPHEMERAL        16
#define BHMSG_POST_ATTENDANCE       17
#define BHMSG_POST_PRODUCT          18

#define BHMSG_POST_PLU_LOOKUP       1
#define BHMSG_POST_PLU_LOGIN        2
#define BHMSG_POST_PLU_IF           3
#define BHMSG_POST_PLU_PRICE        4
#define BHMSG_POST_PLU_WEIGHT       5
#define BHMSG_POST_PLU_QTY          6
#define BHMSG_POST_PLU_TOKEN        7
#define BHMSG_POST_PLU_VOUCHER      8
#define BHMSG_POST_PLU_INSTORE      9
#define BHMSG_POST_PLU_PRICESHORT   10
#define BHMSG_POST_PLU_WEIGHTSHORT  11
#define BHMSG_POST_PLU_QTYSHORT     12
#define BHMSG_POST_PLU_TOKENSHORT   13
#define BHMSG_POST_PLU_VOUCHERSHORT 14
#define BHMSG_POST_PLU_INSTORESHORT 15
#define BHMSG_POST_PLU_PRICELONG    16
#define BHMSG_POST_PLU_WEIGHTLONG   17
#define BHMSG_POST_PLU_QTYLONG      18
#define BHMSG_POST_PLU_TOKENLONG    19
#define BHMSG_POST_PLU_VOUCHERLONG  20
#define BHMSG_POST_PLU_INSTORELONG  21
#define BHMSG_POST_PLU_REQNOLUP     22
#define BHMSG_POST_PLU_REQLC        23
#define BHMSG_POST_PLU_REQEXP       24
#define BHMSG_POST_PLU_PRICEBREAK   25
#define BHMSG_POST_PLU_MINMAX       26

/* post transaction sub-commands */
#define BHMSG_POST_TRANSACTION_NEW             1
#define BHMSG_POST_TRANSACTION_AUTH            2
#define BHMSG_POST_TRANSACTION_ADD             3
#define BHMSG_POST_TRANSACTION_SELECT          4
#define BHMSG_POST_TRANSACTION_COMMIT          5
#define BHMSG_POST_TRANSACTION_DELETE          6
#define BHMSG_POST_TRANSACTION_STORE           7
#define BHMSG_POST_TRANSACTION_RETRIEVE        8
#define BHMSG_POST_TRANSACTION_RET_PLU         9
#define BHMSG_POST_TRANSACTION_RET_UPLU        10
#define BHMSG_POST_TRANSACTION_RET_PT          12
#define BHMSG_POST_TRANSACTION_RET_END         13
#define BHMSG_POST_TRANSACTION_COMMIT_PLU      14
#define BHMSG_POST_TRANSACTION_COMMIT_UPLU     15
#define BHMSG_POST_TRANSACTION_COMMIT_PRICEPLU 16
#define BHMSG_POST_TRANSACTION_COMMIT_PT       17
#define BHMSG_POST_TRANSACTION_END             18
#define BHMSG_POST_TRANSACTION_CANCEL          19
#define BHMSG_POST_TRANSACTION_PAYAUTH         20
#define BHMSG_POST_TRANSACTION_DEFER           21
#define BHMSG_POST_TRANSACTION_INFOREDIR       22
#define BHMSG_POST_TRANSACTION_ADDITEM         23
#define BHMSG_POST_TRANSACTION_EMSTORE         24
#define BHMSG_POST_TRANSACTION_SUMMARY         25
#define BHMSG_POST_TRANSACTION_NEWEX           26
#define BHMSG_POST_TRANSACTION_RETURNSGET      27
#define BHMSG_POST_TRANSACTION_RETURNSNEW      28
#define BHMSG_POST_TRANSACTION_RETURNS         29
#define BHMSG_POST_TRANSACTION_RETURNS_PLU     30
#define BHMSG_POST_TRANSACTION_RETURNS_UPLU    31
#define BHMSG_POST_TRANSACTION_RETURNS_END     32
#define BHMSG_POST_TRANSACTION_PRETURNS_END    33
#define BHMSG_POST_TRANSACTION_GOODSIN         34
#define BHMSG_POST_TRANSACTION_GOODSIN_PLU     35
#define BHMSG_POST_TRANSACTION_GOODSIN_UPLU    36
#define BHMSG_POST_TRANSACTION_GOODSIN_END     37
#define BHMSG_POST_TRANSACTION_RESTORE         38
#define BHMSG_POST_TRANSACTION_ADDPAYITEM      39
#define BHMSG_POST_TRANSACTION_CUSTSUMMARY     40
#define BHMSG_POST_TRANSACTION_RECALL          41
#define BHMSG_POST_TRANSACTION_VOID            42
#define BHMSG_POST_TRANSACTION_NOSALE          43
#define BHMSG_POST_TRANSACTION_RENTAL_PLU      44
#define BHMSG_POST_TRANSACTION_LAYBY_PLU       45
#define BHMSG_POST_TRANSACTION_CASHBACKCHK     46
#define BHMSG_POST_TRANSACTION_MICRCOMMIT      47
#define BHMSG_POST_TRANSACTION_CREDITCOMMIT    48
#define BHMSG_POST_TRANSACTION_CREDITDONE      49

/* post adjust sub-commands */
#define BHMSG_POST_ADJUST_CASHDRAWER        1
#define BHMSG_POST_ADJUST_PAYIN             2
#define BHMSG_POST_ADJUST_PAYOUT            3

/* post query sub-commands */
#define BHMSG_POST_QUERY_STATUS             1
#define BHMSG_POST_QUERY_MODE               2
#define BHMSG_POST_QUERY_WHO                3
#define BHMSG_POST_QUERY_TIME               4
#define BHMSG_POST_QUERY_CASH               5
#define BHMSG_POST_QUERY_CLIENTS            6
#define BHMSG_POST_QUERY_UPTIME             7

/* post service sub-commands */
#define BHMSG_POST_SERVICE_REQUEST_SUPER     1
#define BHMSG_POST_SERVICE_REQUEST_CHANGE    2
#define BHMSG_POST_SERVICE_REQUEST_AUTH      3
#define BHMSG_POST_SERVICE_REQUEST_PROBLEM   4
#define BHMSG_POST_SERVICE_REQUEST_BREAK     5

#define BHMSG_POST_SERVICE_SUMMARY_TRANS     16
#define BHMSG_POST_SERVICE_SUMMARY_USER      17
#define BHMSG_POST_SERVICE_SUMMARY_XTAPE     18
#define BHMSG_POST_SERVICE_SUMMARY_ZTAPE     19

#define BHMSG_POST_SERVICE_KEYMAPACK         32

#define BHMSG_POST_PRINTER_SETUP             100
#define BHMSG_POST_PRINTER_INIT              101
#define BHMSG_POST_PRINTER_PREPRINT          102
#define BHMSG_POST_PRINTER_HDR               103
#define BHMSG_POST_PRINTER_ITEM              104
#define BHMSG_POST_PRINTER_TRANSSUM          105
#define BHMSG_POST_PRINTER_PAYSUM            106
#define BHMSG_POST_PRINTER_FTR               107
#define BHMSG_POST_PRINTER_POSTPRINT         108
#define BHMSG_POST_PRINTER_JRNPREPRINT       109
#define BHMSG_POST_PRINTER_JRNITEM           110
#define BHMSG_POST_PRINTER_JRNPOSTPRINT      111
#define BHMSG_POST_PRINTER_LBLPREPRINT       112
#define BHMSG_POST_PRINTER_LBLITEM           113
#define BHMSG_POST_PRINTER_LBLPOSTPRINT      114
#define BHMSG_POST_PRINTER_CHKPREPRINT       115
#define BHMSG_POST_PRINTER_CHKITEM           116
#define BHMSG_POST_PRINTER_CHKPOSTPRINT      117
#define BHMSG_POST_PRINTER_SLIPPREPRINT      118
#define BHMSG_POST_PRINTER_SLIPHEADER        119
#define BHMSG_POST_PRINTER_SLIPITEM          120
#define BHMSG_POST_PRINTER_SLIPFOOTER        121
#define BHMSG_POST_PRINTER_SLIPPOSTPRINT     122
#define BHMSG_POST_PRINTER_ENDPREPRINT       123
#define BHMSG_POST_PRINTER_ENDITEM           124
#define BHMSG_POST_PRINTER_ENDPOSTPRINT      125
#define BHMSG_POST_PRINTER_MICRPREREAD       126
#define BHMSG_POST_PRINTER_MICRREAD          127
#define BHMSG_POST_PRINTER_MICRSTATUS        128
#define BHMSG_POST_PRINTER_MICRPOSTREAD      129
#define BHMSG_POST_PRINTER_CUSTDISPPRESALE   130
#define BHMSG_POST_PRINTER_CUSTDISPPOSTSALE  131
#define BHMSG_POST_PRINTER_CUSTDISPIDLE      132

#define BHMSG_POST_STATE_KA                     1
#define BHMSG_POST_STATE_STATUS                 2
#define BHMSG_POST_STATE_DETAILS                3
#define BHMSG_POST_STATE_TRANSACTION            4
#define BHMSG_POST_STATE_TRANSACTION_RET        5
#define BHMSG_POST_STATE_TRANSACTION_RET_PLU    6
#define BHMSG_POST_STATE_TRANSACTION_RET_UPLU   7
#define BHMSG_POST_STATE_TRANSACTION_RET_PT     8
#define BHMSG_POST_STATE_TRANSACTION_RET_END    9

#define BHMSG_POST_LIST_TAX                     1
#define BHMSG_POST_LIST_PRICE                   2
#define BHMSG_POST_LIST_PREFIX                  3
#define BHMSG_POST_LIST_RETURNREASON            4
#define BHMSG_POST_LIST_PAYTYPES                5

#define BHMSG_POST_STOCKTAKE_PLU                1
#define BHMSG_POST_STOCKTAKE_ITEM               2

#define BHMSG_POST_SIGNATURE_COMMIT             1
#define BHMSG_POST_SIGNATURE_DATA               2
#define BHMSG_POST_SIGNATURE_END                3
#define BHMSG_POST_SIGNATURE_RETRIEVE           4
#define BHMSG_POST_SIGNATURE_RETDATA            5
#define BHMSG_POST_SIGNATURE_RETEND             6

#define BHMSG_POST_BLINDBALANCE_TRANSAMOUNT     1
#define BHMSG_POST_BLINDBALANCE_CONTENTS        2
#define BHMSG_POST_BLINDBALANCE_CHEQUELIST      3
#define BHMSG_POST_BLINDBALANCE_COUPONLIST      4
#define BHMSG_POST_BLINDBALANCE_VOUCHERLIST     5

#define BHMSG_POST_DELIVERY_ADD                 1
#define BHMSG_POST_DELIVERY_LIST                2
#define BHMSG_POST_DELIVERY_STATUS              3
#define BHMSG_POST_DELIVERY_RETURNLIST          4
#define BHMSG_POST_DELIVERY_DUE                 5
#define BHMSG_POST_DELIVERY_PAYMENT             6
#define BHMSG_POST_DELIVERY_UNDELIVERED         7

#define BHMSG_POST_RENTAL_ADD                   1
#define BHMSG_POST_RENTAL_LIST                  2
#define BHMSG_POST_RENTAL_STATUS                3
#define BHMSG_POST_RENTAL_RETURN                4
#define BHMSG_POST_RENTAL_DUE                   5
#define BHMSG_POST_RENTAL_PAYMENT               6

#define BHMSG_POST_EPHEMERAL_LOOKUP             1
#define BHMSG_POST_EPHEMERAL_COMMIT             2
#define BHMSG_POST_EPHEMERAL_PLU                3
#define BHMSG_POST_EPHEMERAL_END                4
#define BHMSG_POST_EPHEMERAL_STATUS             5

#define BHMSG_POST_DISCREPANCY_BLINDBALANCE     1

#define BHMSG_POST_CUSTOMER_NEW                 1
#define BHMSG_POST_CUSTOMER_LIST                2
#define BHMSG_POST_CUSTOMER_DISCOUNT            3
#define BHMSG_POST_CUSTOMER_PRODUCTS            4
#define BHMSG_POST_CUSTOMER_CHARGEBAL           5

#define BHMSG_POST_ATTENDANCE_CLOCKIN           1
#define BHMSG_POST_ATTENDANCE_CLOCKOUT          2

#define BHMSG_POST_PRODUCT_FIND                 1
#define BHMSG_POST_PRODUCT_FINDBOOK             2

/******************************************
 *
 * Service commands 
 *
 ******************************************/
#define BHMSG_SERVICE_SYSTEM     1
#define BHMSG_SERVICE_CLIENT     2
#define BHMSG_SERVICE_SITE       3
#define BHMSG_SERVICE_MESSAGE    4
#define BHMSG_SERVICE_DATABASE   5
#define BHMSG_SERVICE_CUSTOMER   6
#define BHMSG_SERVICE_FINANCIAL  7
#define BHMSG_SERVICE_PNP        8
#define BHMSG_SERVICE_CCV        9
#define BHMSG_SERVICE_KEYMAP     10

#define BHMSG_SERVICE_SYSTEM_STATUS             1
#define BHMSG_SERVICE_SYSTEM_SHUTDOWN1          2
#define BHMSG_SERVICE_SYSTEM_SHUTDOWN2          3
#define BHMSG_SERVICE_SYSTEM_SHUTDOWN3          4
#define BHMSG_SERVICE_SYSTEM_NUMCLIENTS         5
#define BHMSG_SERVICE_SYSTEM_NUMTRANSOPEN       6
#define BHMSG_SERVICE_SYSTEM_LOAD               7
#define BHMSG_SERVICE_SYSTEM_MAXLOAD            8
#define BHMSG_SERVICE_SYSTEM_WAKE_POST          9
#define BHMSG_SERVICE_SYSTEM_WAKE_ALL           10
#define BHMSG_SERVICE_SYSTEM_VERSION_SERVER     11
#define BHMSG_SERVICE_SYSTEM_VERSION_CLIENT     12
#define BHMSG_SERVICE_SYSTEM_VERSION_PROTOCOL   13
#define BHMSG_SERVICE_SYSTEM_PING               14
#define BHMSG_SERVICE_SYSTEM_CLIENTACK          15

#define BHMSG_SERVICE_SITE_SITE_NUM             1
#define BHMSG_SERVICE_SITE_SITE_DETAILS         2
#define BHMSG_SERVICE_SITE_SITE_ACTIVE          3
#define BHMSG_SERVICE_SITE_DEPT_NUM             4
#define BHMSG_SERVICE_SITE_DEPT_DETAILS         5
#define BHMSG_SERVICE_SITE_DEPT_ACTIVE          6
#define BHMSG_SERVICE_SITE_GROUP_NUM            7
#define BHMSG_SERVICE_SITE_GROUP_DETAILS        8
#define BHMSG_SERVICE_SITE_GROUP_ACTIVE         9
#define BHMSG_SERVICE_SITE_STATION_NUM          10
#define BHMSG_SERVICE_SITE_STATION_DETAILS      11
#define BHMSG_SERVICE_SITE_STATION_ACTIVE       12

/* client subcmds */
#define BHMSG_SERVICE_CLIENT_GET          1
#define BHMSG_SERVICE_CLIENT_SET          2
#define BHMSG_SERVICE_CLIENT_GETREQ       3
#define BHMSG_SERVICE_CLIENT_ACKREQ       4
#define BHMSG_SERVICE_CLIENT_DEFINEHDRBM  5
#define BHMSG_SERVICE_CLIENT_DEFINEFTRBM  6
#define BHMSG_SERVICE_CLIENT_DEFINEHDRMSG 7
#define BHMSG_SERVICE_CLIENT_DEFINEFTRMSG 8
#define BHMSG_SERVICE_CLIENT_GETCASH      9
#define BHMSG_SERVICE_CLIENT_SETCASH      10

/* blah blah blah */
#define BHMSG_SERVICE_DATABASE_PLUGET      1
#define BHMSG_SERVICE_DATABASE_PLUSET      2
#define BHMSG_SERVICE_DATABASE_PLUEADD     3
#define BHMSG_SERVICE_DATABASE_PLUEDELETE  4
#define BHMSG_SERVICE_DATABASE_PLUEGET     5

#define BHMSG_SERVICE_CUSTOMER_NEW       1
#define BHMSG_SERVICE_CUSTOMER_STORE     2
#define BHMSG_SERVICE_CUSTOMER_RETRIEVE  3

#define BHMSG_SERVICE_PNP_START          1
#define BHMSG_SERVICE_PNP_END            2

#define BHMSG_SERVICE_CCV_POLICY         1
#define BHMSG_SERVICE_CCV_AMOUNT         2

#define BHMSG_SERVICE_KEYMAP_SET         1
#define BHMSG_SERVICE_KEYMAP_DROP        2
#define BHMSG_SERVICE_KEYMAP_ADD         3
#define BHMSG_SERVICE_KEYMAP_EDIT        4
#define BHMSG_SERVICE_KEYMAP_DELETE      5

/*****************************************************************
 *
 * Scales commands 
 *
 ****************************************************************/
#define BHMSG_SCALES_PLU            1
#define BHMSG_SCALES_ITEMCODE       2
#define BHMSG_SCALES_PQ_LOOKUP      3


/*****************************************************************
 *
 * Remote Printer commands 
 *
 ****************************************************************/
#define BHMSG_RPRINTER_CONNECT   1
#define BHMSG_RPRINTER_SETUP     2
#define BHMSG_RPRINTER_PRINT     3
#define BHMSG_RPRINTER_STATUS    4

#define BHMSG_RPRINTER_CONNECT_STATUS          1
#define BHMSG_RPRINTER_CONNECT_CONNECT         2
#define BHMSG_RPRINTER_CONNECT_DISCONNECT      3

#define BHMSG_RPRINTER_SETUP_SETUP             1
#define BHMSG_RPRINTER_SETUP_INIT              2
#define BHMSG_RPRINTER_SETUP_PREPRINT          3
#define BHMSG_RPRINTER_SETUP_HDR               4
#define BHMSG_RPRINTER_SETUP_ITEM              5
#define BHMSG_RPRINTER_SETUP_TRANSSUM          6
#define BHMSG_RPRINTER_SETUP_PAYSUM            7
#define BHMSG_RPRINTER_SETUP_FTR               8
#define BHMSG_RPRINTER_SETUP_POSTPRINT         9
#define BHMSG_RPRINTER_SETUP_JRNPREPRINT       10
#define BHMSG_RPRINTER_SETUP_JRNITEM           11
#define BHMSG_RPRINTER_SETUP_JRNPOSTPRINT      12
#define BHMSG_RPRINTER_SETUP_LBLPREPRINT       13
#define BHMSG_RPRINTER_SETUP_LBLITEM           14
#define BHMSG_RPRINTER_SETUP_LBLPOSTPRINT      15
#define BHMSG_RPRINTER_SETUP_CHKPREPRINT       16
#define BHMSG_RPRINTER_SETUP_CHKITEM           17
#define BHMSG_RPRINTER_SETUP_CHKPOSTPRINT      18
#define BHMSG_RPRINTER_SETUP_SLIPPREPRINT      19
#define BHMSG_RPRINTER_SETUP_SLIPHEADER        20
#define BHMSG_RPRINTER_SETUP_SLIPITEM          21
#define BHMSG_RPRINTER_SETUP_SLIPFOOTER        22
#define BHMSG_RPRINTER_SETUP_SLIPPOSTPRINT     23
#define BHMSG_RPRINTER_SETUP_ENDPREPRINT       24
#define BHMSG_RPRINTER_SETUP_ENDITEM           25
#define BHMSG_RPRINTER_SETUP_ENDPOSTPRINT      26
#define BHMSG_RPRINTER_SETUP_MICRPREREAD       27
#define BHMSG_RPRINTER_SETUP_MICRREAD          28
#define BHMSG_RPRINTER_SETUP_MICRSTATUS        29
#define BHMSG_RPRINTER_SETUP_MICRPOSTREAD      30

#define BHMSG_RPRINTER_STATUS_STATUS           1
#define BHMSG_RPRINTER_STATUS_RESET            2

/******************************************
 *
 * goods commands 
 *
 ******************************************/
#define BHMSG_GOODS_IN                1
#define BHMSG_GOODS_OUT               2
#define BHMSG_GOODS_TRANSFERIN        3
#define BHMSG_GOODS_TRANSFEROUT       4
 
#define BHMSG_GOODS_IN_POLIST         1
#define BHMSG_GOODS_IN_POFETCH        2
#define BHMSG_GOODS_IN_POCOMMIT       3

#define BHMSG_GOODS_OUT_ORDERLIST     1
#define BHMSG_GOODS_OUT_ORDERFETCH    2
#define BHMSG_GOODS_OUT_ORDERCOMMIT   3

#define BHMSG_GOODS_TRANSFERIN_LIST    1
#define BHMSG_GOODS_TRANSFERIN_FETCH   2
#define BHMSG_GOODS_TRANSFERIN_COMMIT  3

#define BHMSG_GOODS_TRANSFEROUT_LIST   1
#define BHMSG_GOODS_TRANSFEROUT_FETCH  2
#define BHMSG_GOODS_TRANSFEROUT_COMMIT 3

/******************************************
 *
 * menu commands 
 *
 ******************************************/
#define BHMSG_MENU_IN               1
#define BHMSG_MENU_OUT              2
#define BHMSG_MENU_MENU             3
#define BHMSG_MENU_HEADING          4
#define BHMSG_MENU_ITEM             5
#define BHMSG_MENU_ITEMOPTIONS      6

#define BHMSG_MENU_IN_LIST          1
#define BHMSG_MENU_IN_FETCH         2
#define BHMSG_MENU_IN_COMMIT        3

#define BHMSG_MENU_OUT_LIST         1
#define BHMSG_MENU_OUT_FETCH        2
#define BHMSG_MENU_OUT_COMMIT       3

#define BHMSG_MENU_MENU_GET         1

#define BHMSG_MENU_HEADING_GET      1

#define BHMSG_MENU_ITEM_GET         1

#define BHMSG_MENU_ITEMOPTIONS_GET  1

/******************************************
 *
 * server side transaction commands 
 * stuff for remote menuing - restaurant like
 * where server holds transactional information
 *
 ******************************************/
#define BHMSG_SERVERSIDE_TRANS   1
#define BHMSG_SERVERSIDE_PLU     2
#define BHMSG_SERVERSIDE_ADD     3
#define BHMSG_SERVERSIDE_EDIT    4
#define BHMSG_SERVERSIDE_DELETE  5
 
#define BHMSG_SERVERSIDE_TRANS_NEW        1
#define BHMSG_SERVERSIDE_TRANS_LIST       2
#define BHMSG_SERVERSIDE_TRANS_STATUS     3
#define BHMSG_SERVERSIDE_TRANS_RETRIEVE   4
#define BHMSG_SERVERSIDE_TRANS_ADD        5
#define BHMSG_SERVERSIDE_TRANS_TARGETLIST 6
#define BHMSG_SERVERSIDE_TRANS_AUTH       7
#define BHMSG_SERVERSIDE_TRANS_SELECT     8
#define BHMSG_SERVERSIDE_TRANS_COMMIT     9
#define BHMSG_SERVERSIDE_TRANS_DELETE     10
#define BHMSG_SERVERSIDE_TRANS_STORE      11
#define BHMSG_SERVERSIDE_TRANS_RET        12
#define BHMSG_SERVERSIDE_TRANS_END        13
#define BHMSG_SERVERSIDE_TRANS_CANCEL     14
#define BHMSG_SERVERSIDE_TRANS_PAYAUTH    15
#define BHMSG_SERVERSIDE_TRANS_DEFER      16
#define BHMSG_SERVERSIDE_TRANS_INFOREDIR  17
#define BHMSG_SERVERSIDE_TRANS_ADDTO      18
#define BHMSG_SERVERSIDE_TRANS_NEXT       19
#define BHMSG_SERVERSIDE_TRANS_PREV       20
#define BHMSG_SERVERSIDE_TRANS_MOVEUSER   21
#define BHMSG_SERVERSIDE_TRANS_PICKUP     22
#define BHMSG_SERVERSIDE_TRANS_DROP       23

#define BHMSG_SERVERSIDE_PLU_ADD     1
#define BHMSG_SERVERSIDE_PLU_EDIT    2
#define BHMSG_SERVERSIDE_PLU_REMOVE  3

/******************************************
 *
 * synch commands 
 *
 ******************************************/
#define BHMSG_SYNCH_TRANSACTION           1
#define BHMSG_SYNCH_DATABASE              2
#define BHMSG_SYNCH_DBABS                 3

/* sub commands */
#define BHMSG_SYNCH_TRANSACTION_START     1
#define BHMSG_SYNCH_TRANSACTION_ITEMS     2
#define BHMSG_SYNCH_TRANSACTION_PAYITEMS  3
#define BHMSG_SYNCH_TRANSACTION_END       4
#define BHMSG_SYNCH_RETURNS_START         5
#define BHMSG_SYNCH_RETURNS_ITEMS         6
#define BHMSG_SYNCH_RETURNS_END           7
#define BHMSG_SYNCH_GOODSIN_START         8
#define BHMSG_SYNCH_GOODSIN_ITEMS         9
#define BHMSG_SYNCH_GOODSIN_END           10
#define BHMSG_SYNCH_GOODSOUT_START        11
#define BHMSG_SYNCH_GOODSOUT_ITEMS        12
#define BHMSG_SYNCH_GOODSOUT_END          13
#define BHMSG_SYNCH_GOODSTRANFER_START    14
#define BHMSG_SYNCH_GOODSTRANSFER_ITEMS   15
#define BHMSG_SYNCH_GOODSTRANSFER_END     16
#define BHMSG_SYNCH_ADJUSTMENT_START      17
#define BHMSG_SYNCH_ADJUSTMENT_ITEMS      18
#define BHMSG_SYNCH_ADJUSTMENT_END        19
#define BHMSG_SYNCH_RENTAL_START          20
#define BHMSG_SYNCH_RENTAL_ITEMS          21
#define BHMSG_SYNCH_RENTAL_END            22
#define BHMSG_SYNCH_LAYBY_START           23
#define BHMSG_SYNCH_LAYBY_ITEMS           24
#define BHMSG_SYNCH_LAYBY_END             25
#define BHMSG_SYNCH_DISCREPANCY_START     26
#define BHMSG_SYNCH_DISCREPANCY_ITEMS     27
#define BHMSG_SYNCH_DISCREPANCY_END       28

#define BHMSG_SYNCH_DATABASE_ADDPROD      1
#define BHMSG_SYNCH_DATABASE_ADDINV       2
#define BHMSG_SYNCH_DATABASE_ADDSELLPRICE 3
#define BHMSG_SYNCH_DATABASE_ADDBUYPRICE  4
#define BHMSG_SYNCH_DATABASE_ADDPROMO     4
#define BHMSG_SYNCH_DATABASE_ADDTOKEN     5
#define BHMSG_SYNCH_DATABASE_ADDVOUCHER   6
#define BHMSG_SYNCH_DATABASE_ADDSUPPLIER  7
#define BHMSG_SYNCH_DATABASE_ADDCUSTOMER  8
#define BHMSG_SYNCH_DATABASE_ADDUSER      9
#define BHMSG_SYNCH_DATABASE_ADDEMPLOYEE  10
#define BHMSG_SYNCH_DATABASE_ADDRAW       11
#define BHMSG_SYNCH_DATABASE_MODPROD      12
#define BHMSG_SYNCH_DATABASE_MODINV       13
#define BHMSG_SYNCH_DATABASE_MODSELLPRICE 14
#define BHMSG_SYNCH_DATABASE_MODBUYPRICE  15
#define BHMSG_SYNCH_DATABASE_MODPROMO     16
#define BHMSG_SYNCH_DATABASE_MODTOKEN     17
#define BHMSG_SYNCH_DATABASE_MODVOUCHER   18
#define BHMSG_SYNCH_DATABASE_MODSUPPLIER  19
#define BHMSG_SYNCH_DATABASE_MODCUSTOMER  20
#define BHMSG_SYNCH_DATABASE_MODUSER      21
#define BHMSG_SYNCH_DATABASE_MODEMPLOYEE  22
#define BHMSG_SYNCH_DATABASE_MODRAW       23
#define BHMSG_SYNCH_DATABASE_DELPROD      24
#define BHMSG_SYNCH_DATABASE_DELINV       25
#define BHMSG_SYNCH_DATABASE_DELSELLPRICE 26
#define BHMSG_SYNCH_DATABASE_DELBUYPRICE  27
#define BHMSG_SYNCH_DATABASE_DELPROMO     28
#define BHMSG_SYNCH_DATABASE_DELTOKEN     29
#define BHMSG_SYNCH_DATABASE_DELVOUCHER   30
#define BHMSG_SYNCH_DATABASE_DELSUPPLIER  31
#define BHMSG_SYNCH_DATABASE_DELCUSTOMER  32
#define BHMSG_SYNCH_DATABASE_DELUSER      33
#define BHMSG_SYNCH_DATABASE_DELEMPLOYEE  34
#define BHMSG_SYNCH_DATABASE_DELRAW       35

/******************************************
 *
 * raw SQL commands 
 *
 ******************************************/
#define BHMSG_RAWSQL_RAW       1
#define BHMSG_RAWSQL_CREATE    2
#define BHMSG_RAWSQL_DROP      3
#define BHMSG_RAWSQL_ALTER     4
#define BHMSG_RAWSQL_INSERT    5
#define BHMSG_RAWSQL_SELECT    6
 

/*********************************************
 *
 * some error codes - for the error server
 *
 *********************************************/

/* System errors */
#define BHMSG_ERROR_SYSTEM            		 	 1
#define BHMSG_ERROR_OPERATION         		 	 2
#define BHMSG_ERROR_WARNING           		 	 3
#define BHMSG_ERROR_DELIVERY          		 	 4
#define BHMSG_ERROR_RENTAL          		 	 5
#define BHMSG_ERROR_LAYBY	          		 	 6
#define BHMSG_ERROR_EPHEMERAL         		 	 7

/* system errors*/
#define BHMSG_ERROR_SYSTEM_UNKNOWN            0
#define BHMSG_ERROR_SYSTEM_CLIENTVERSION   	 1
#define BHMSG_ERROR_SYSTEM_PROTOCOLVERSION 	 2
#define BHMSG_ERROR_SYSTEM_SERVERVERSION   	 3

#define BHMSG_ERROR_OPERATION_PLUNOTFOUND     1
#define BHMSG_ERROR_OPERATION_CCV             2
#define BHMSG_ERROR_OPERATION_TRANFAIL        3

/* warnings */
#define BHMSG_ERROR_WARNING_HIGHTIDEMARK	    1
#define BHMSG_ERROR_WARNING_LOWTIDEMARK		 2

/* operational errors */
#define BHMSG_ERROR_DELIVERY_NOUSER        	 1
#define BHMSG_ERROR_DELIVERY_NODELIVERY    	 2

#define BHMSG_ERROR_EPHEMERAL_NOPLU        	 1
#define BHMSG_ERROR_EPHEMERAL_NORX         	 2
#define BHMSG_ERROR_EPHEMERAL_RXREADY      	 3
#define BHMSG_ERROR_EPHEMERAL_RXDONE       	 4
#define BHMSG_ERROR_EPHEMERAL_UNKNOWN      	 5

/* generic stuff */
#define BHPOS_REFUSE       0
#define BHPOS_GRANT        1

/* values */
#define BH_MODE_DEBUG      1
#define BH_MODE_VERBOSE    2

typedef struct tagBhHdr{
   unsigned char  type;
   unsigned char  cmd;
   unsigned char  subcmd;
   unsigned char  Ex;
   unsigned short msgID;
   unsigned short sessionID;
   int            timestamp;
   unsigned short flags;
   unsigned short size;
}BhHdr;

#define BHPOSMSG_TYPE(m) ((unsigned char) ((unsigned int) m & 0xFF000000) >> 24 )
#define BHPOSMSG_CMD(m)  ((unsigned char) ((unsigned int) m & 0x00FF0000) >> 16 )
#define BHPOSMSG_SUB(m)  ((unsigned char) ((unsigned int) m & 0x0000FF00) >> 8 )
#define BHPOSMSG_EX(m)   ((unsigned char) ((unsigned int) m & 0x000000FF))

typedef struct tagBhPosMsg{
   int      ClientID;
   int      sd;
   int      flags;
   struct   sockaddr_in return_addr;  // to be replaced later with below...
   BhHdr    hdr;   
   char     data[1024];       // and onward...
}BhPosMsg;

typedef struct tagBhPosHdr{
   BhHdr   hdr;   
   char    data[1024];
}BhPosHdr;

typedef struct tagBhVersion{
   unsigned char  MajorVersion;
   unsigned char  MinorVersion;
   unsigned char  BuildVersion;
   unsigned char  packermack;
}BhVersion;

/*******************************************
 *
 * Connection and stuff
 *
 *******************************************/
#define BHPOS_LOGIN_TYPES_KEYBOARD     1
#define BHPOS_LOGIN_TYPES_PASSIVE      2
#define BHPOS_LOGIN_TYPES_BARCODE      3
#define BHPOS_LOGIN_TYPES_MAGSWIPE     4
#define BHPOS_LOGIN_TYPES_SMARTCARD    5
#define BHPOS_LOGIN_TYPES_FINGERPRINT  6
#define BHPOS_LOGIN_TYPES_RETINA       7
#define BHPOS_LOGIN_TYPES_VOICE        8

typedef struct tagBhPosConnect{
   unsigned char mac[6];
   BhVersion     postver;
}BhPosConnect;

#define BHPOS_CASHOPERATION_SET        1
#define BHPOS_CASHOPERATION_ADD        2
#define BHPOS_CASHOPERATION_SUBTRACT   3

typedef struct tagBhPosMonetaryUnit{
   int     unit;
   double  value;
   int     amount;
   int     operation;
}BhPosMonetaryUnit;

// site is implicit in this struct
typedef struct tagBhPosConnectReply{
   int             SiteID;
   int             DeparmentID;
   int             GroupID;
   int             PostID;
   int             baseCurrency;
   int             locale;
   int             status;
   int             mode;
   unsigned int    logintypes;
   unsigned short  pktmax;
   char            pktEncryption;
   char            pktCompress;
   unsigned int    defaulttacaccount;
   unsigned char   numtaxitems;
   unsigned char   numpriceitems;
   unsigned char   numpayitems;
   unsigned char   numbollocksitems;
   char            currency_majname[32];
   char            currency_minname[31];
   char            roundtype;
   float           roundunit;
   BhPosMonetaryUnit unit[1];
}BhPosConnectReply;

typedef struct tagBhPosSConnectReply{
   int             SiteID;
   int             DeparmentID;
   int             GroupID;
   int             PostID;
   int             status;
   int             mode;
   unsigned int    logintypes;
   unsigned short  pktmax;
   char            pktEncryption;
   char            pktCompress;
}BhPosSConnectReply;

typedef struct tagBhAuth1{
   char        method[16];
   int         blksize;
   BhVersion   cyptver;
   char        plaintext[128];
   char        crypttext[128];
}BhAuth1;

typedef struct tagBhAuth2{
   char  crypttext[128];
   char  plaintext[128];
}BhAuth2;

typedef struct tagBhPosMoneyRequest{
   int baseCurrency;
   int locale;
}BhPosMoneyRequest;

typedef struct tagBhPosMoneyReply{
   int  baseCurrency;
   int  locale;
   char num_units;
   BhPosMonetaryUnit unit[1];
}BhPosMoneyReply;

// casting types
typedef struct tagBhLogonRequest{
   int   postID;
   char  name[32];
   char  password[32];
}BhLogonRequest;

typedef struct tagBhLogonRequestBarcode{
	int  postID;
   char barcode[128];
}BhLogonRequestBaroode;

typedef struct tagBhLogonRequestMagswipe{
	int   postID;
   char  track1[80];
   char  track2[41];
   char  cardnum[20];
   char  expdate[5];
}BhLogonRequestMagswipe;

typedef struct tagBhMagswipe{
   union {
      char raw[80];
      union{
         char formatcode[2];
         char pan[20];
         char name[27];
         char expdate[5];
         char servicecode[3];
         char pvki[2];
         char pvv[5];
         char ccv[3];
         char pack[13];
      }track1_details;
   }track1;
   union{
      char raw[41];
      union{
         char pan[20];
         char expdate[5];
         char servicecode[3];
         char pvki[2];
         char pvv[5];
         char ccv[3];
         char pack[3];
      }track2_details;
   }track2;
   union{
      char raw [107];
      union{
         char pan[20];
         char countrycode[4];
         char currencycode[4];
         char currency_expon[2];
         char amountauthpercycle[5];
         char amountremainoncycle[5];
         char cyclebegin[5];
         char cyclelength[3];
         char retrycount[2];
         char pincontrolparms[7];
         char interchangecontrol[2];
         char panservicerestriction[3];
         char sab1servicerestriction[3];
         char expdate[5];
         char cardsequencenumber[2];
         char cardsecuritynumber[10];
         char pack[3];
      }track3_details;
   }track3;
}BhMagswipe;

// a generic type
typedef struct tagBhLogonRequestEx{
   int   postID;
   short type;
   union{
		char raw[146];
      union {
         char login[32];
         char password[32];
      }login;
      BhMagswipe magswipe;
	}data;
}BhLogonRequestEx;

typedef struct tagBhLogonReply{
   int   userID;
   int   interfaceID;
   char  userdispname[32];
}BhLogonReply;

typedef struct tagBhLogonReplyEx{
   int   userID;
   int   interfaceID;
   char  userdispname[16];
   BhPosMonetaryUnit unit[1];
}BhLogonReplyEx;

typedef struct tagBhInterfaceRequestBarcode{
   int   type;
   int   flags;
   char  barcode[16];
}BhInterfaceRequestBarcode;

typedef struct tagBhInterfaceReply{
   int   userID;
   int   interfaceID;
   char  userdispname[16];
}BhInterfaceReply;

typedef struct tagBhClockin{
   int	type;
   char  data[64];
}BhClockIn;

typedef struct tagBhLogout{
   int   postID;
   int   userID;
}BhLogout;

typedef struct tagBhTimestamp{
   char  flags;
   short year;
   char  month;
   char  date;
   char  hour;
   char  minute;
   char  second;
}BhTimestamp;

typedef struct tagBhExPaytype{
   int   ID;
   char  name[32];
   bool  cashback;
   float limit;
}BhExPaytype;

typedef struct tagBhExPaytypeList{
   int         num_types;
   BhExPaytype item[1];
}BhExPaytypeList;

/*******************************************
 *
 * Error stuff
 *
 *******************************************/
typedef struct tagBhErrorMsg{
   char  enteredAt[32];
   int   userID;
   int   type;
   char  more[128];
}BhErrorMsg;

typedef struct tagBhWarningTidemark{
   double tidemark;
	double amount;
}BhWarningTidemark;

/*******************************************
 *
 * PLU stuff
 *
 *******************************************/

// some plu types
#define BH_PLU_WEIGHTSHORT     1
#define BH_PLU_WEIGHTLONG      2
#define BH_PLU_QTYSHORT        3
#define BH_PLU_QTYLONG         4
#define BH_PLU_PRICESHORT      5
#define BH_PLU_PRICELONG       6
#define BH_PLU_TOKENSHORT      7
#define BH_PLU_TOKENLONG       8
#define BH_PLU_VOUCHERSHORT    9
#define BH_PLU_VOUCHERLONG     10
#define BH_PLU_LOGIN           11
#define BH_PLU_IF              12
#define BH_PLU_INSTORE         13

#define BH_DEPOSIT_TYPE_RENTAL           1
#define BH_DEPOSIT_TYPE_LAYBY            2
#define BH_DEPOSIT_TYPE_RETURNABLE       3
#define BH_DEPOSIT_TYPE_REDEMPTION       4

#define BH_DEPOSIT_AMOUNTTYPE_AMOUNT     1
#define BH_DEPOSIT_AMOUNTTYPE_PERCENTAGE 2

typedef struct tagBhDepositRequest{
   int   transID;
   int   type;
   char  PLU[16];
}BhDepositRequest;

typedef struct tagBhDepositReply{
   int    transID;
   int    type;
   int    amount_type;
   double number;
}BhDepositReply;

typedef struct tagBhTaxListItem{
   int    ID;
   double rate;
   char   name[32];
}BhTaxListItem;

typedef struct tagBhTaxList{
   int            numitems;
   BhTaxListItem  item[1];
}BhTaxList;

typedef struct tagBhReturnReasonItem{
   int    ID;
   char   name[64];
}BhReturnReasonItem;

typedef struct tagBhReturnReasonList{
   int            	 numitems;
   BhReturnReasonItem item[1];
}BhReturnReasonList;

typedef struct tagBhPriceListItem{
   int    ID;
   int    AccountID;
   char   name[32];
}BhPriceListItem;

typedef struct tagBhPriceList{
   int             numitems;
   BhPriceListItem item[1];
}BhPriceList;

typedef struct tagBhPLUrequest{
   int   transID;
   int   type;
   int   qty;
   char  PLU[16];
}BhPLUrequest;

typedef struct tagBhPLUrequestEx{
   int   transID;
   int   type;
   int   qty;
   char  PLU[128];
}BhPLUrequestEx;

#define ITEMDISCOUNT_TYPE_NONE       0
#define ITEMDISCOUNT_TYPE_MARGIN     1
#define ITEMDISCOUNT_TYPE_ABSOLUTE   2
#define ITEMDISCOUNT_TYPE_INCREMTAL  3

typedef struct tagBhPLUreply{
   int            transID;
   char           PLU[16];
   char           displayText[64];
   char           recuText[32];
   float          tax;
   char           discounttype;
   char           deposittype;
   float          discount;
   float          unitPrice;
   float          deposit;
   unsigned short flags;
}BhPLUreply;

typedef struct tagBhPLUreplyMin{
   int            transID;
   char           PLU[16];
   char           displayText[64];
   char           recuText[32];
   float          tax;
   char           discounttype;
   char           deposittype;
   float          discount;
   float          unitPrice;
   float          recunitPrice;
   float          minunitPrice;
   float          deposit;
   unsigned short flags;
}BhPLUreplyMin;

typedef struct tagBhDiscount{
   float discount;
}BhDiscount;

typedef struct tagBhPriceBreakItem{
   int   lower_bound;
   int   upper_bound;
   float discount;
}BhPriceBreakItem;

typedef struct tagBhPriceBreak{
   int              num_items;
   BhPriceBreakItem item[1];
}BhPriceBreak;

#define ITEMFLAG_TYPE_NONE    0
#define ITEMFLAG_TYPE_MSG     1
#define ITEMFLAG_TYPE_AUTH    2
#define ITEMFLAG_TYPE_RECORD  3
#define ITEMFLAG_TYPE_PRICEBR 0xFF 

typedef struct tagItemFlag{
   char  flagdata[1];
}ItemFlag;

typedef struct tagItemReturn{
   unsigned int transnum;
   char         creditref[32];
   int          numitems;
   char         PLU[16];
}ItemReturn;

typedef struct tagBhPrinterMsg{
   int   size;
   int   flags;
   char  data[1];
}BhPrinterMsg;

/*******************************************
 *
 * Transaction stuff
 *
 *******************************************/
#define TRANSACTIONFLAG_TYPE_IDONLY     1
#define TRANSACTIONFLAG_TYPE_SALE       2
#define TRANSACTIONFLAG_TYPE_RETURN     3
#define TRANSACTIONFLAG_TYPE_EPHEMIN    4
#define TRANSACTIONFLAG_TYPE_ADJUSTMENT 5 
#define TRANSACTIONFLAG_TYPE_LINK       6
#define TRANSACTIONFLAG_TYPE_RECONCILE  7
#define TRANSACTIONFLAG_TYPE_IN         8
#define TRANSACTIONFLAG_TYPE_OUT        9
#define TRANSACTIONFLAG_TYPE_MULTI      10

#define TRANSACTIONCANCEL_TYPE_CLOSE    1
#define TRANSACTIONCANCEL_TYPE_VOID     2

typedef struct tagBhTransactionNew{
   int    transID;
   int    flags;
   int    sid;
}BhTransactionNew;

typedef struct tagBhTransactionGet{
   int   transID;
   int   flags;
}BhTransactionGet;

typedef struct tagBhTransactionCancel{
   int    transID;
   int    type;
}BhTransactionCancel;

typedef struct tagBhTransPayAuth{
   int            transID;
   int            stationID;
   int            userID;
   unsigned char  flags;
   unsigned char  type;
   double         amount;
}BhTransPayAuth;

typedef struct tagBhCreditReply{
   BhTransPayAuth pa;
	long  batchID;
	long  batchItemID;
	long  transTrackID;
   long  AVSResponse;
	long  CVResponse;
   char  authID[32];
}BhCreditReply;

typedef struct tagBhTransPayCredit{
	BhTransPayAuth pa;
   char  track1[80];
   char  track2[41];
   char  cardnum[20];
   char  expdate[5];
}BhTransPayCredit;

typedef struct tagBhChequeTransit{
   char RoutingNumber[5];
   char BankID[5];
   char checkdigit;
}BhChequeTransit;

typedef struct tagBhChequeFormattedData{
	unsigned char type;
	unsigned char flags;
	union{
		char				transit_r[12];
		BhChequeTransit transit_f;
	}transit;
	char onus[20];
	char amount[11];
	char auxonus[11];
}BhChequeFormattedData;

typedef struct tagBhTransPayCheque{
   int            transID;
   unsigned char  flags;
   unsigned char  type;
   double         amount;
   union{
      char                  raw[62];
      BhChequeFormattedData formatted;
   }data;
}BhTransPayCheque;

typedef struct tagBhTransPayCharge{
   int            transID;
   unsigned char  flags;
   unsigned char  type;
   int            customerID;
   double         amount;
}BhTransPayCharge;

typedef struct tagBhTransPayAuthReply{
   int            transID;
   unsigned char  bAccepted;
   unsigned char  bRequireSupervisor;
   unsigned char  flags;
   char           recText[32];
   char           Reason[1];
}BhTransPayAuthReply;

/*******************************************
 *
 * Transaction Commit
 *
 *******************************************/

#define BHTRANS_ITEMFLAG_NONE       1
#define BHTRANS_ITEMFLAG_UNKNOWNPLU 2

typedef struct tagBhTransItem{
   char PLU[16];
   int  flags;
   int  type;
   int  quantity;
}BhTransItem;

typedef struct tagBhTransItemUPLU{
   char  PLU[16];
   int   flags;
   int   quantity;
   float unitPrice;
   float tax;
   char  description[64];
}BhTransItemUPLU;

typedef struct tagBhTransPayment{
   int     type;
   int     flags;
   double  amount;
}BhTransPayment;

#define TRANS_COMMIT_FLAG_SALE   0
#define TRANS_COMMIT_FLAG_RETURN 1

typedef struct tagBhTransCommit{
   int    transID;
   short  flags;   // whether to close trans (i.e. store)
   short  delivery;
   int    customerID;
   int    returnreasonID;
   int    total_items;
   int    total_unknownitems;
   int    total_returnitems;
   int    total_rentalitems;
   int    total_laybyitems;
   int    total_payment_types;
   double total_tax;
   double total_discount;
   double change;
   double total;
}BhTransCommit;

typedef struct tagBhTransPluCommit{
   int          transID;
   int          num_items;
   BhTransItem  items[1];
}BhTransPluCommit;

typedef struct tagBhTransUPluCommit{
   int               transID;
   int               num_items;
   BhTransItemUPLU   items[1];
}BhTransUPluCommit;

typedef struct tagBhTransPaymentCommit{
   int            transID;
   int            num_items;
   BhTransPayment payment[1];
}BhTransPaymentCommit;

typedef struct tagBhTransEnd{
   int transID;
}BhTransEnd;

typedef struct tagBhCashbackCheck{
	int   type;
	float amount;
}BhCashbackCheck;

typedef struct tagBhCashbackReply{
	int   flags;
	float max;
}BhCashbackReply;

/*******************************************
 *
 * Transaction Recall
 *
 *******************************************/
 
#define TRANSRETRIEVE_FLAGS_SALE     0x00000001
#define TRANSRETRIEVE_FLAGS_PAY      0x00000002
#define TRANSRETRIEVE_FLAGS_RETURNS  0x00000004
#define TRANSRETRIEVE_FLAGS_LAYBYS   0x00000008
#define TRANSRETRIEVE_FLAGS_RENTALS  0x00000010
#define TRANSRETRIEVE_FLAGS_ALL      0x0000FFFF

typedef struct tagBhRetPLUreply{
   char          PLU[16];
   char          displayText[64];
   char          recuText[32];
   float         tax;
   char          discounttype;
   float         discount;
   char          deposittype;
   float         deposit;
   float         unitPrice;
   int           quantity;
   int           site;
   int           dept;
   int           group;
   int           station;
   int           user;
   BhTimestamp   when;
   unsigned char flags;
   unsigned char type;
}BhRetPLUreply;

typedef struct tagBhTransRetPayment{
   int         type;
   int         flags;
   int         site;
   int         dept;
   int         group;
   int         station;
   int         user;
   BhTimestamp when;
   double      amount;
}BhTransRetPayment;

typedef struct tagBhTransRetrieve{
   int          transID;
   unsigned int flags;
}BhTransRetrieve;

typedef struct tagBhTransRetrieveReply{
   int    transID;
   int    total_items;
   int    total_unknownitems;
   int    total_returns;
   int    total_rental;
   int    total_layby;
   int    total_payment_types;
   double total_tax;
   double total_discount;
   double total;
}BhTransRetrieveReply;

typedef struct tagBhTransPluRetrieve{
   int           transID;
   int           num_items;
   BhRetPLUreply items[1];
}BhTransPluRetrieve;

typedef struct tagBhTransReturnRetrieve{
   int           transID;
   int           num_items;
   BhRetPLUreply items[1];
}BhTransReturnRetrieve;

typedef struct tagBhTransUPluRetrieve{
   int           transID;
   int           num_items;
   BhRetPLUreply items[1];
}BhTransUPluRetrieve;

typedef struct tagBhTransPaymentRetrieve{
   int               transID;
   int               num_items;
   BhTransRetPayment payment[1];
}BhTransPaymentRetrieve;

typedef struct tagBhStockTakeItem{
   char PLU[16];
   int  qty;
}BhStockTakeItem;

typedef struct tagBhTransListItem{
   int         id;
   BhTimestamp timestamp;
   int         status;
   int         type;
   int         num_items;
   float       total;
}BhTransListItem;

typedef struct tagBhTransList{
   int             num_items;
   BhTransListItem items[1];
}BhTransList;

typedef struct tagBhTranstListItem{
   int  ID;
   char item[32];
}BhTranstListItem;

typedef struct tagBhTransItemList{
   int             num_items;
   BhTransListItem item[1];
}BhTransItemList;

typedef struct tagBhTransReturnReasonCommit{
   int transID;
   int num_items;
   int rrid[1];
}BhTransReturnReasonCommit;

typedef struct tagBhTransPayItem{
   int     type;
   int     flags;
   double  amount;
}BhTransPayItem;

typedef struct tagBhTransPayList{
   int            transID;
   int            num_items;
   BhTransPayItem item[1];
}BhTransPayList;

#define CASHD_ADJUSTMENT_TYPE_ABSOLUTE      1
#define CASHD_ADJUSTMENT_TYPE_INCREMENTAL   2
#define CASHD_ADJUSTMENT_TYPE_DECCREMENTAL  3

typedef struct tagBhCashDrawerAdjust{
   int   num_units;
   int   adjustment_type;
   BhPosMonetaryUnit unit[1];
}BhCashDrawerAdjust;

typedef struct tagBhPayinAdjust{
   int    type;
   double amount;
}BhPayinAdjust;

typedef struct tagBhPayoutAdjust{
   int    type;
   double amount;
}BhPayoutAdjust;

typedef struct tagBhBlindBalance{
   int flags;
}BhBlindBalance;

typedef struct tagBhBlindBalanceReply{
   double opening_balance;
   double closing_balance;
   int    num_cheques;
   int    num_coupons;
   int    num_vouchers;
}BhBlindBalanceReply;

typedef struct tagBhBlindBalanceFullReply{
   int    num_units;
   double opening_balance;
   double amount_transacted;
   BhPosMonetaryUnit unit[1];
}BhBlindBalanceFullReply;

typedef struct tagBhBlindBalanceChequeItem{
   int    flags;
	char	 num[32];
   double amount;
}BhBlindBalanceChequeItem;

typedef struct tagBhBlindBalanceChequeList{
   int							 num_cheques;
   double						 total_amount;
   BhBlindBalanceChequeItem item[1];
}BhBlindBalanceChequeList;

typedef struct tagBhBlindBalanceCouponItem{
   int    flags;
	char	 num[32];
   double amount;
}BhBlindBalanceCouponItem;

typedef struct tagBhBlindBalanceCouponList{
   int							 num_coupons;
   double						 total_coupons;
	int							 num_vouchers;
   double						 total_vouchers;
   BhBlindBalanceCouponItem item[1];
}BhBlindBalanceCouponList;

typedef struct tagBhCustomerLookup{
   int  customerID;
   char fname[32];
   char lname[32];
   char phone[32];
   char barcode[32];
   char swipedata[128];
}BhCustomerLookup;

typedef struct tagBhCustomerItem{
   int  customerID;
   char fname[32];
   char lname[32];
   char phone[32];
   char address1[64];
   char address2[64];
   char address3[64];
   char city[32];
   char state[8];
   char zip[16];
   char country[32];
}BhCustomerItem;

typedef struct tagBhCustomerList{
   int              num_items;
   BhCustomerItem item[1];
}BhCustomerList;

typedef struct tagBhCustomerCharBal{
   int   customerID;
   float amount;
}BhCustomerCharBal;

typedef struct tagBhCustomerCharBalRet{
   int   customerID;
   float old_balance;
   float new_balance;
   float limit;
}BhCustomerCharBalRet;

typedef struct tagBhProductLookup{
   char name[32];
   char desciption[64];
   char keywords[128];
}BhProductLookup;

typedef struct tagBhProductItem{
   char plu[128];
   char name[32];
   char desciption[64];
}BhProductItem;

typedef struct tagBhProductList{
   int           num_items;
   BhProductItem item[1];
}BhProductList;

typedef struct tagBhBookLookup{
   char isbn[16];
   char title[32];
   char author[32];
}BhBookLookup;

typedef struct tagBhBookItem{
   char isbn[16];
   char title[32];
   char author[32];
}BhBookItem;

typedef struct tagBhBookList{
   int        num_items;
   BhBookItem item[1];
}BhBookList;

typedef struct tagBhDeliveryLookup{
   int   customerID;
   int   deliveryID;
}BhDeliveryLookup;

typedef struct tagBhDeliveryItem{
   int   customerID;
   int   deliveryID;
   int   num_items;
   float total;
   char  fname[32];
   char  lname[32];
   char  address[64];
}BhDeliveryItem;

typedef struct tagBhDeliveryList{
   int              num_items;
   BhDeliveryItem item[1];
}BhDeliveryList;

typedef struct tagBhDeliveryOut{
   int deliveryID;
   int userID;
   int delivererID;
   int flags;
}BhDeliveryOut;

typedef struct tagBhDeliveryOutList{
   int           num_items;
   BhDeliveryOut item[1];
}BhDeliveryOutList;

typedef struct tagBhDeliveryReturnLookup{
   int  customerID;
   int  deliveryID;
   int  delivererID;
   int  transactionID;
   float total;
   char  fname[32];
   char  lname[32];
   char  address[64];
}BhDeliveryReturnLookup;

typedef struct tagBhDeliveryReturnList{
   int                    num_items;
   BhDeliveryReturnLookup item[1];
}BhDeliveryReturnList;

typedef struct tagBhDeliveryPayment{
   int   deliveryID;
   int   flags;
   int   payment_type;
   float amount;
}BhDeliveryPayment;

typedef struct tagBhDeliveryPaymentList{
   int               num_items;
   BhDeliveryPayment item[1];
}BhDeliveryPaymentList;

typedef struct tagBhDeliveryReturnItem{
   int  customerID;
   int  deliveryID;
   int  delivererID;
}BhDeliveryReturnItem;

typedef struct tagBhDeliveryItemList{
   int                  num_items;
   BhDeliveryReturnItem item[1];
}BhDeliveryItemList;

typedef struct tagBhRentalItem{
   int         customerID;
   int         rentalID;
   int         transactionID;
   BhTimestamp outat;
   char        outfrom[32];
   int         duration;
   char        fname[32];
   char        lname[32];
   char        description[32];
}BhRentalItem;

typedef struct tagBhRentalList{
   int          num_items;
   BhRentalItem item[1];
}BhRentalList;

typedef struct tagBhRentalReturn{
   int rentalID;
}BhRentalReturn;

typedef struct tagBhRentalReturnDue{
   int   rentalID;
   int   flags;
   int   duration;
   float duration_rate;
   float deposit;
}BhRentalReturnDue;

typedef struct tagBhRentalPayment{
   int   rentalID;
   int   flags;
   int   payment_type;
   float amount;
}BhRentalPayment;

typedef struct tagBhLaybyItem{
   int         transID;
   int         num_items;
   int         num_payitems;
   float       total;
   float       paid;
   BhTimestamp when;
}BhLaybyItem;

typedef struct tagBhLaybyList{
   int customerID;
   int numtrans;
   BhLaybyItem item[1];
}BhLaybyList;

typedef struct tagBhTransEphemLookup{
   int  flags;
   char PLU[128];
}BhTransEphemLookup;

typedef struct tagBhTransEphemLookupError{
   int  error;
}BhTransEphemLookupError;

typedef struct tagBhTransEphemLookupReturn{
   int   flags;
   int   rx_id;
   int   customerID;
   char  description[32];
   char  rxnumber[32];
	char  updated[32];
   char  fname[32];
   char  lname[32];
	float price;
}BhTransEphemLookupReturn;

typedef struct tagBhTransEphemItem{
   char PLU[16];
   int  rxid;
   int  flags;
}BhTransEphemItem;

typedef struct tagBhTransEphemCommit{
   int num_items;
	BhTransEphemItem items[1];
}BhTransEphemCommit;

typedef struct tagBhTransEphemPluCommit{
   int              num_items;
   BhTransEphemItem items[1];
}BhTransEphemPluCommit;


/******************************************
 *
 * remote printing structures
 *
 ******************************************/

typedef struct tagBhRemotePrintStatus{
   int   ID;
   int   flags;
}BhRemotePrintStatus;

typedef struct tagBhRemotePrintStatusReply{
   int   ID;
   int   flags;
   char  name[32];
}BhRemotePrintStatusReply;

typedef struct tagBhRemotePrintItem{
   int   ID;
   int   flags;
   char  PLU[16];
   int   productID;   
   int   quantity;
   char  extra_data[64];
}BhRemotePrintItem;

typedef struct tagBhRemotePrint{
   int   ID;
   int   targetprinterID;
   int   senderID;
   int   targetID;
   int   num_items;
   BhRemotePrintItem items[1];
}BhRemotePrint;

typedef struct tagBhRemotePrintLabel{
   int   ID;
   int   flags;
   char  PLU[16];
   int   description[32];
   char  bbcwithnum;
   char  extra_data[61];
}BhRemotePrintLabel;


/*******************************************
 *
 * Discrepancy stuff
 *
 *******************************************/
 
#define BHDISCREPANCY_TYPE_BLINDBALANCE   1

typedef struct tagBhDiscrepancy{
   int    ID;
   int    flags;
   int    type;
   double amount;
   char   extra_data[64];
}BhDiscrepancy;

/******************************************
 *
 * goods structures
 *
 ******************************************/

typedef struct tagBhGoodsInListItem{
   int  supplierid;
   char suppliername[64];
   char ponumber[32];
   int  num_items;
}BhGoodsInListItem;

typedef struct tagBhGoodsInList{
   int num_items;
	BhGoodsInListItem items[1];
}BhGoodsInList;

typedef struct tagBhGoodsInItem{
   int  quantity;
   char plu[16];
   char description[64];
}BhGoodsInItem;

typedef struct tagBhGoodsInPO{
   int num_items;
	BhGoodsInItem items[1];
}BhGoodsInPO;

/******************************************
 *
 * service structures
 *
 ******************************************/
typedef struct tagBhServiceTransSumItem{
   int    type;
   int    num;
   double amount;
}BhServiceTransSumItem;

typedef struct tagBhServiceTransSum{
   int                   num_users;
   int                   num_trans;
   int                   num_items;
   int                   num_nosale;
   int                   num_voidsale;
   int                   num_returns;
   int                   num_payin;
   int                   num_payout;
   double                total_sold;
   double                total_returns;
   double                total_payin;
   double                total_payout;
   double                opening_balance;
   double                closing_balance;
   BhServiceTransSumItem item[1];
}BhServiceTransSum;

typedef struct tagBhServicePaySumItem{
   int    type;
   int    num;
   double amount;
}BhServicePaySumItem;

typedef struct tagBhServicePaySum{
   int                 num_items;
   BhServicePaySumItem item[1];
}BhServicePaySum;

typedef struct tagBhServiceUserSumItem{
   int      ID;
   char     name[32];
   int      num_nosale;
   int      num_voidsale;
   int      num_trans;
   double   total_payin;
   double   total_payout;
   double   total_transacted;
   int      num_login;
   char     start[6];
   char     end[6];
   char     total[6];
}BhServiceUserSumItem;

typedef struct tagBhServiceUserSum{
   int   num_users;
   BhServiceUserSumItem user[1];
}BhServiceUserSum;

typedef struct tagBhServiceDbAddEPLU{
   int    RefID;
   char   PLU[16];
   char   Name[64];
   char   RecuText[64];
   double UnitPrice;
   float  Tax;
}BhServiceDbAddEPLU;

typedef struct tagBhServiceDbRetEPLU{
   int                num_eplu;
   BhServiceDbAddEPLU items[1];
}BhServiceDbRetEPLU;

typedef struct tagBhServiceClient{
   int   clientID;
   int   site;
   int   department;
   int   group;
   int   station;
}BhServiceClient;


typedef struct tagBhServiceHdr{
   int   type;
   int   site;
   int   dept;
   int   group;
   int   post;
}BhServiceHdr;

typedef struct tagBhServiceCash{
   BhServiceHdr hdr;
   int          targetUnit;
   double       targetValue;
   double       amount;
}BhServiceCash;

typedef struct tagBhServiceKeymap{
   BhServiceHdr hdr;
   char         filename[1];
}BhServiceKeymap;

typedef struct tagBhStandardKey{
   int            key_type;
   unsigned int   key;
   unsigned int   src_modifiers;
   int            target_type;
   int            target_len;
   unsigned int   target;
   unsigned int   trg_modifiers;
   int            type;
   int            group;
}BhStandardKey;

typedef struct tagBhImageKey{
   int           key_type;
   unsigned int  key;
   unsigned int  src_modifiers;
   int           target_type;
   int           target_len;
   unsigned int  target;
   unsigned int  trg_modifiers; 
   int           type;
   int           group;
   int           x,y,w,h;
   int           img_size;
   unsigned char imagedata[1];
}BhImageKey;

typedef struct tagBhStandardKeys{
   int           numKeys;
   BhStandardKey mapper;
}BhServiceStandardKeys;

typedef struct tagBhServiceNum{
   int   flags;
   int   num;
}BhServiceNum;

#define BHPOS_SERVSITEFLAG_ALL            1
#define BHPOS_SERVSITEFLAG_ACTIVE         2
#define BHPOS_SERVSITEFLAG_TARGETALL      3
#define BHPOS_SERVSITEFLAG_TARGETACTIVE   4

typedef struct tagBhServiceSiteNum{
   int   flags;
   int   targetID;
   int   num;
   int   ID[1];
}BhServiceSiteNum;

typedef struct tagBhServiceSite{
   int   flags;
   int   num;
   int   targetID;
   int   ID;
   char  name[64];
   int   status;
   int   numDepartments;
   int   numActiveDepartments;
}BhServiceSite;

typedef struct tagBhServiceDept{
   int   flags;
   int   num;
   int   targetID;
   int   ID;
   char  name[64];
   int   status;
   int   numGroups;
   int   numActiveGroups;
}BhServiceDept;

typedef struct tagBhServiceGroup{
   int   flags;
   int   num;
   int   targetID;
   int   ID;
   char  name[64];
   int   status;
   int   numStations;
   int   numActiveStations;
}BhServiceGroup;

typedef struct tagBhServiceStation{
   int   flags;
   int   num;
   int   targetID;
   int   ID;
   char  name[64];
   int   status;
   int   userID;
   char  username[64];
}BhServiceStation;

/*****************************************************************
 *
 * State structures 
 *
 ****************************************************************/

// get the initial state machine

typedef struct tagBhStateStatus{
   int   transID;
   int   userID;
   char  username[16];
}BhStateStatus;

// repeat the connection type info, from here the station
// can trans retrieve or whatever to recover last state

typedef struct tagBhPosStateDetails{
   int SiteID;
   int DeparmentID;
   int GroupID;
   int PostID;
   int baseCurrency;
   int locale;
   int status;
   int mode;
   unsigned int   logintypes;
   unsigned short pktmax;
   char pktEncryption;
   char pktCompress;
   unsigned short numtaxitems;
   unsigned short numpriceitems;
   BhPosMonetaryUnit unit[1];
}BhPosStateDetails;


/*****************************************************************
 *
 * Remote Menuing structures 
 * these float on top of the the standard transactions things
 *
 ****************************************************************/

typedef struct tagBhSSTransListItem{
   int         id;
   BhTimestamp timestamp;
   char        name[32];
   int         status;
   int         type;
   int         num_items;
   float       total;
}BhSSTransListItem;

typedef struct tagBhSSTransList{
   int             num_items;
   BhSSTransListItem items[1];
}BhSSTransList;

typedef struct tagBhMenuRequest{
   int   type;
   int   id;
}BhMenuRequest;

typedef struct tagBhMenu{
   int   id;
   char  name[32];
   char  description[64];
   int   areaid;
}BhMenu;

typedef struct tagBhMenuHeading{
   int   id;
   char  name[32];
   char  image[64];
}BhMenuHeading;

typedef struct tagBhMenuHeadingList{
   int           num_items;
   BhMenuHeading items[1];
}BhMenuHeadingList;

typedef struct tagBhMenuItemRequest{
   int        menuid;
}BhMenuItemRequest;

typedef struct tagBhMenuItem{
   int   id;
   char  name[32];
   char  rectext[64];
   char  quantity[64];
   char  image[64];
   float price;
   float tax;
   int   printerid;
}BhMenuItem;

typedef struct tagBhMenuItemList{
   int        num_items;
   BhMenuItem items[1];
}BhMenuItemList;

typedef struct tagBhMenuItemOptionRequest{
   int        menuitemid;
}BhMenuItemOptionRequest;

typedef struct tagBhMenuItemOption{
   int   id;
   char  name[32];
}BhMenuItemOption;

typedef struct tagBhMenuItemOptionList{
   int              num_items;
   BhMenuItemOption items[1];
}BhMenuItemOptionList;

typedef struct tagBhTransRoverTargetListRequest{
   int   flags;
   int   postID;
   int   userID;
}BhTransRoverTargetListRequest;

typedef struct tagBhTransRoverTargetListItem{
   int   ID;
   int   status;
   char  target[32];
}BhTransRoverTargetListItem;

typedef struct tagBhTransRoverTargetList{
   int   ID;
   int   num_items;
   BhTransRoverTargetListItem item[1];
}BhTransRoverTargetList;

typedef struct tagBhTransRoverNew{
   int   ID;
   int   flags;
   int   postID;
   int   userID;
   int   targetID;
}BhTransRovernew;

typedef struct tagBhTransRoverListRequest{
   int   flags;
   int   postID;
   int   userID;
}BhTransRoverListRequest;

typedef struct tagBhTransRoverListItem{
   int   ID;
   int   status;
   int   userID;
   int   num_items;
   char  name[32];
   char  target[32];
   float amount;
}BhTransRoverListItem;

typedef struct tagBhTransRoverList{
   int   ID;
   int   num_items;
   BhTransRoverListItem item[1];
}BhTransRoverList;

typedef struct tagBhTransRoverPickup{
   int   ID;
   int   flags;
   int   postID;
   int   userID;
}BhTransRoverPickup;

typedef struct tagBhTransRoverDrop{
   int   ID;
   int   flags;
   int   postID;
   int   userID;
}BhTransRoverDrop;

typedef struct tagBhRoverTargetItem{
   int ID;
   int target_ID;
   int target_num;
   int actual_num;
   int status;
}BhRoverTargetItem;

typedef struct tagBhFrontDeskCollect{
   int ID;
   int num_available;
   int num_open;
   int num_outstanding;
   int num_inprogress;
   int num_requests;
   BhRoverTargetItem item[1];
}BhFrontDeskCollect;

typedef struct tagBhFrontDeskUpdate{
   int ID;
   int target_ID;
   int status;
   int target_num;
}BhFrontDeskUpdate;

typedef struct tagBhFrontDeskReconcile{
   int ID;
   int target_ID;
}BhFrontDeskReconcile;


/*****************************************************************
 *
 * Synchronization structures 
 *
 ****************************************************************/
typedef struct tagBhSynchConnect{
   unsigned int   id;
   unsigned int   sessionid;
}BhSynchConnect;


/*****************************************************************
 *
 * Scales structures 
 *
 ****************************************************************/
typedef struct tagBhScalesPLU{
   char           PLU[16];
   unsigned char  type;
   unsigned char  unit_type;
   double         quantity;
}BhScalesPLU;

typedef struct tagBhScalesItemCode{
   unsigned int   code;
   unsigned char  type;
   unsigned char  unit_type;
   double         quantity;
}BhScalesItemCode;

typedef struct tagBhScalesReply{
   char           PLU[16];
   unsigned char  type;
   unsigned char  unit_type;
   double         quantity;     // allows on the fly updating
   double         price;
   char           description[64];
   char           barcode[16];
}BhScalesReply;

typedef struct tagBhScalesPQLookup{
   unsigned int   code;
   char           PLU[16];
   unsigned char  type;
   unsigned char  unit_type;
   char           unit_name[32];
   double         price_perunit;
}BhScalesPQLookup;

typedef struct tagBhScalesPQReply{
   char           PLU[16];
   unsigned int   code;
   unsigned char  type;
   unsigned char  unit_type;
   double         quantity;     // allows on the fly updating
   double         price;
   char           description[64];
   char           barcode_prefix[8];
   char           barcode_format[32];
}BhScalesPQReply;

/*************************************************************
 *
 * Signature stuff
 *
 *************************************************************/

#define BHPOS_SIGNATURE_UNSPECIFICED   0
#define BHPOS_SIGNATURE_PATIENT        1
#define BHPOS_SIGNATURE_PRIVACY        2
#define BHPOS_SIGNATURE_RXPICKUP       3
#define BHPOS_SIGNATURE_ACCEPTCOUNSEL  4
#define BHPOS_SIGNATURE_DECLINECOUNSEL 5
#define BHPOS_SIGNATURE_CREDIT         6
#define BHPOS_SIGNATURE_INHOUSE        7

typedef struct tagBhSignatureCommit{
   int          id;
   int          type;
   int          xdim;
   int          ydim;
   int          depth;
   unsigned int size;
   int          data[1];
}BhSignatureCommit;

typedef struct tagBhSignatureData{
   int          id;
   unsigned int size;
   int          data[1];
}BhSignatureData;

typedef struct tagBhSignatureEnd{
   int          id;
}BhSignatureEnd;

/*************************************************************
 *
 * Global set stuff
 *
 *************************************************************/

typedef struct tagGlobalPrint{
   int   setup_size;
   int   init_size;
   int   preprint_size;
   int   header_size;
   int   item_size;
   int   transsum_size;
   int   paysum_size;
   int   footer_size;
   int   postprint_size;
   int   slip_preprint_size;
   int   slip_header_size;
   int   slip_item_size;
   int   slip_footer_size;
   int   slip_postprint_size;
   int   lbl_preprint_size;
   int   lbl_item_size;
   int   lbl_postprint_size;
   int   jrn_preprint_size;
   int   jrn_item_size;
   int   jrn_postprint_size;
   int   end_preprint_size;
   int   end_item_size;
   int   end_postprint_size;
   int   chk_preprint_size;
   int   chk_item_size;
   int   chk_postprint_size;
   int   micr_preread_size;
   int   micr_read_size;
   int   micr_status_size;
   int   micr_postread_size;
   int   custdisp_presale_size;
   int   custdisp_postsale_size;
   int   custdisp_idle_size;
   char  *setup;
   char  *init;
   char  *preprint;
   char  *header;
   char  *item;
   char  *transsum;
   char  *paysum;
   char  *footer;
   char  *postprint;
   char  *slip_preprint;
   char  *slip_header;
   char  *slip_item;
   char  *slip_footer;
   char  *slip_postprint;
   char  *lbl_preprint;
   char  *lbl_item;
   char  *lbl_postprint;
   char  *jrn_preprint;
   char  *jrn_item;
   char  *jrn_postprint;
   char  *end_preprint;
   char  *end_item;
   char  *end_postprint;
   char  *chk_preprint;
   char  *chk_item;
   char  *chk_postprint;
   char  *micr_preread;
   char  *micr_read;
   char  *micr_status;
   char  *micr_postread;
   char  *custdisp_presale;
   char  *custdisp_postsale;
   char  *custdisp_idle;
}GlobalPrint;

typedef struct tagGlobalPrefix{
   int weight_prefix;
   int quantity_prefix;
   int price_prefix;
   int interface_prefix;
   int token_prefix;
   int voucher_prefix;
   int customer_prefix;
   int instore_prefix;
}GlobalPrefix;

/*************************************************************
 *
 * McStuff
 *
 *************************************************************/
 
/**** multicast types ****/
#define BHMSG_MC_SYSTEM 1
#define BHMSG_MC_CLIENT 2
#define BHMSG_MC_MSG    3
#define BHMSG_MC_MENU   4

/*** multicast system commands ***/
#define BHMSG_MC_SYS_KEEPALIVE   1
#define BHMSG_MC_SYS_STATUS      2
#define BHMSG_MC_SYS_STANDBY     3
#define BHMSG_MC_SYS_SHUTDOWN    4

/*** multicast client commands ***/
#define BHMSG_MC_CLIENT_GET            1
#define BHMSG_MC_CLIENT_SET            2
#define BHMSG_MC_CLIENT_TRANS          3

/* multicast client get subcmds */
#define BHMSG_MC_CLIENT_GET_STATUS     1
#define BHMSG_MC_CLIENT_GET_CASH       2
#define BHMSG_MC_CLIENT_GET_UPS        3

/* multicast client set subcmds */
#define BHMSG_MC_CLIENT_SET_STATUS        1
#define BHMSG_MC_CLIENT_SET_CASH          2
#define BHMSG_MC_CLIENT_SET_KEYMAP        3
#define BHMSG_MC_CLIENT_SET_KEYMAPDROP    4
#define BHMSG_MC_CLIENT_SET_KEYMAPADD     5
#define BHMSG_MC_CLIENT_SET_KEYMAPEDIT    6
#define BHMSG_MC_CLIENT_SET_KEYMAPDELETE  7
#define BHMSG_MC_CLIENT_SET_EXRATE        8
#define BHMSG_MC_CLIENT_SET_PRINTERMSG    9
#define BHMSG_MC_CLIENT_SET_PRINTERBM     10
#define BHMSG_MC_CLIENT_SET_PLUITEM       11
#define BHMSG_MC_CLIENT_SET_PLUFLUSH      12

/*** multicast trans sub commands ***/
#define BHMSG_MC_CLIENT_TRANS_NEW         1
#define BHMSG_MC_CLIENT_TRANS_REMOVE      2
#define BHMSG_MC_CLIENT_TRANS_CHANGE      3

#define BHMSG_MC_MENU_CHANGE              1
#define BHMSG_MC_MENU_ITEMSTATUSCHANGE    2

#define MSG_ALL_SITES   0
#define MSG_ALL_DEPTS   0
#define MSG_ALL_GROUPS  0
#define MSG_ALL_POSTS   0

// for casting in and out of BhPosMsg
typedef struct tagBhMcPosMsg{
   BhHdr hdr;
   int   site;
   int   dept;
   int   group;
   int   post;
   char  data[1008];
}BhMcPosMsg;

typedef struct tagBhMcCash{
   int       targetUnit;
   double    Amount;
}BhMcCash;

typedef struct tagBhMcExchangeRate{
   int       baseCurrencyID;
   int       targetCurrencyID;
   double    rate;
}BhMcExchangeRate;

// transaction stuff
typedef struct tagBhMcTransNew{
   int transid;
   int stationid;
   int userid;
   int status;
}BhMcTransNew;

typedef struct tagBhMcTransRemove{
   int transid;
}BhMcMenuTransRemove;

#define BHMC_CLIENT_TRANSSTATUS_NEW    1
#define BHMC_CLIENT_TRANSSTATUS_PICKUP 2
#define BHMC_CLIENT_TRANSSTATUS_DROP   3
#define BHMC_CLIENT_TRANSSTATUS_ITEMS  4
#define BHMC_CLIENT_TRANSSTATUS_TENDER 5

typedef struct tagBhMcTransChange{
   int   transid;
   int   stationid;
   int   userid;
   int   status;
   int   num_items;
   float total;
}BhMcMenuTransChange;

/*
 * This is only for the add/edit/delete key multicast msg.
 * Keymap downloads are the responsibility of the client.  
 *
 */ 
typedef struct tagBhMcKeyMap{
   BhStandardKey key;
}BhMcKeyMap;

typedef struct tagBhMcPrinterBM{
   unsigned int   target;
   unsigned char  bmnum;
   unsigned char  prtarget;
   unsigned short xdim;
   unsigned short ydim;
   unsigned char  data[1];
}BhMcPrinterBM;

typedef struct tagBhMcPrinterMsg{
   unsigned int   target;
   unsigned char  bmnum;
   unsigned char  prtarget;
   unsigned short fonttarget;
   unsigned char  data[1];
}BhMcPrinterMsg;

typedef struct tagBhMcPluCache{
   unsigned int ID;
   unsigned int time;
}BhMcPluCache;

#define BHMC_MSG_TYPE_STATIC     1
#define BHMC_MSG_TYPE_TLIMIT     2
#define BHMC_MSG_TYPE_PERIODIC   4
#define BHMC_MSG_TYPE_SCROLL     8
#define BHMC_MSG_TYPE_FLASH      16

typedef struct tagBhMcMsg{ 
   char          type;
   float         value;
   float         frequency;
   float         period;
   unsigned char msglen;
   char          msg[255];
}BhMcMsg;

typedef struct tagBhMcMenu{
   int       menuid;
   int       status;
}BhMcMenu;

typedef struct tagBhMcMenuItem{
   int       menuid;
   int       menuitemid;
   int       status;
}BhMcMenuItem;



/**************************************************************/

#define BhServerMajorVersion  (BhVersion.ServerVersion[0])
#define BhServerMinorVersion  (BhVersion.ServerVersion[1])
#define BhServerBuildVersion  (BhVersion.ServerVersion[2])

#define BhProtocolMajorVersion   (BhVersion.ProtocolVersion[0])
#define BhProtocolMinorVersion   (BhVersion.ProtocolVersion[1])
#define BhProtocolBuildVersion   (BhVersion.ProtocolVersion[2])

#define BhClientMajorVersion  (BhVersion.ClientVersion[0])
#define BhClientMinorVersion  (BhVersion.ClientVersion[1])
#define BhClientBuildVersion  (BhVersion.ClientVersion[2])
/*@}*/
#ifdef   __cplusplus
}
#endif

#endif
